#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <XSP2lib.H>
#include "main.h"
#include "enemy.h"
#include "fxsp2lib.h"
#include "parts.h"


#define ENEMY_MAX	64	/* ő吔 */

static ENEMY enemy[ENEMY_MAX];	/* [N */
static ENEMY *enemy_top,	/* gp̃[ÑXg */
 *enemy_null_top,		/* ̃[ÑXg */
 *enemy_end;			/* gp[ÑXg̖ */


extern char end_of_data;
extern char f_option_flag;

typedef struct _spwork {
	signed short x, y;	/* W */
	unsigned short pt;	/* XvCgp^[mD */
	unsigned short info;	/* ]R[hEFEDx\킷f[^ */
} SPWORK;




int EnemyInit0 (void)
{
	int i;

    /* XgȂ */
	enemy_top = NULL;
	enemy_end = NULL;
	enemy_null_top = enemy;
	for (i = 0; i < ENEMY_MAX; i++)
		enemy[i].next = &enemy[i + 1];

	enemy[ENEMY_MAX - 1].next = NULL;

	return (0);
}



void EnemyInit (unsigned short type, unsigned short info,
		signed short ox, signed short oy, ENEMY * parent)
{
	ENEMY *p;

	if (enemy_null_top == NULL) {
		printf ("[Ntł\n");
		return;		/* 󂫂̃[NȂiLN^[I[o[j */
	}
    /* Xg̖ɐVm[hǉ */
	p = enemy_null_top;
	enemy_null_top = p->next;
	if (enemy_top == NULL)
		enemy_top = p;
	else
		enemy_end->next = p;
	p->next = NULL;
	enemy_end = p;

	p->type = type;
	p->info = info;
	p->ox = ox;
	p->oy = oy;
	p->x = p->y = 0;
	p->parent = parent;

	p->lx = p->ly = p->lz = 0.0;
	p->vx = p->vy = p->vz = 0.0;
	p->cyc = 0;
	p->cyc1 = 0;
	p->round = p->round_v = p->spring = p->spring_v = 0.0;
	switch (type) {
	case 1:
	case 2:
		p->round = M_PI / 2.0;
		break;
	}
}



/* ̃XvCgō\Ăp[cP̃XvCg܂Ƃ߂ĕ\ */
static void DispSp (ENEMY * p, short sp_num, PARTS_TABLE * parts_table)
{
	short h;
	SPWORK spwork;

	for (h = 0; h < sp_num; h++) {
		p->x = p->lx + p->ox;
		p->y = p->ly + p->oy;
		if (p->parent != NULL) {
			spwork.x = p->x + p->parent->x + parts_table[h].x;
			spwork.y = p->y + p->parent->y + parts_table[h].y;
		} else {
			spwork.x = p->x + parts_table[h].x;
			spwork.y = p->y + parts_table[h].y;
		}
		spwork.pt = parts_table[h].pt;
		spwork.info = p->info;

		spwork.x += (128 + 16);	/* \pɕ␳ */
		spwork.y += (128 + 16);
		xsp_set_st (&spwork);
		fxsp_set_st (&spwork);
		spwork.x -= (128 + 16);
		spwork.y -= (128 + 16);
	}
}



void EnemyMove (void)
{
	ENEMY *p, *q;

	p = enemy_top;
	q = NULL;
	while (p != NULL) {
		char erase_flag = 0;

		switch (p->type) {
		case 0:	/* { */
			DispSp (p, 18, parts0_table);
			break;

		case 1:	/*  */
			switch (p->cyc) {
#define R1	8		/* a */
#define RA1	(0.04)		/* x */
#define RV1_MAX (0.3)		/* xől */
			case 0:/* ] */
				p->round += p->round_v;
				if ((p->round_v += RA1) > RV1_MAX)
					p->round_v = RV1_MAX;
				p->lx = R1 * cos (p->round);
				p->ly = R1 * sin (p->round);
#define R1_MAX (M_PI)
				if (p->round > R1_MAX) {
					p->round -= R1_MAX;
					p->cyc++;
				}
				break;
			case 1:/* ΂ːU */
#define SPRING_K1	0.5
#define SPRING_M1	0.8	/* Cv */
#define ROUND_MIN1	0.03	/* WȉɂȂΒf */
#define ROUNDV_MIN1	0.10	/* xȉɂȂΒf */
				p->round += p->round_v;
				p->round_v -= SPRING_K1 * p->round;
				p->round_v *= SPRING_M1;
				if ((fabs (p->round) < ROUND_MIN1) && (fabs (p->round_v) < ROUNDV_MIN1))
					p->cyc++;
				p->lx = R1 * cos (R1_MAX + p->round);
				p->ly = R1 * sin (R1_MAX + p->round);
				break;
			case 2:
				p->lx = R1 * cos (R1_MAX + p->round);
				p->ly = R1 * sin (R1_MAX + p->round);
				break;
			default:
				break;
			}
			DispSp (p, 9, parts1_table);
			break;

		case 2:	/* E */
			switch (p->cyc) {
			case 0:/* ] */
				p->round += p->round_v;
				if ((p->round_v += RA1) > RV1_MAX)
					p->round_v = RV1_MAX;
				p->lx = -R1 * cos (p->round);
				p->ly = R1 * sin (p->round);
				if (p->round > R1_MAX) {
					p->round -= R1_MAX;
					p->cyc++;
				}
				break;
			case 1:/* ΂ːU */
				p->round += p->round_v;
				p->round_v -= SPRING_K1 * p->round;
				p->round_v *= SPRING_M1;
				if ((fabs (p->round) < ROUND_MIN1) && (fabs (p->round_v) < ROUNDV_MIN1))
					p->cyc++;
				p->lx = -R1 * cos (R1_MAX + p->round);
				p->ly = R1 * sin (R1_MAX + p->round);
				break;
			case 2:
				p->lx = -R1 * cos (R1_MAX + p->round);
				p->ly = R1 * sin (R1_MAX + p->round);
				end_of_data = !0;
				break;
			default:
				break;
			}
			DispSp (p, 9, parts2_table);
			break;

		default:
			printf ("enemy_move() : oOĂ܂\n");
			break;
		}

		if (erase_flag) {
			if (q == NULL) {	/* Xg̈ԍŏ폜 */
				enemy_top = p->next;
				p->next = enemy_null_top;
				enemy_null_top = p;
				q = NULL;
				p = enemy_top;
			} else {
				if (p == enemy_end) {	/* Xg̈ԍŌ폜 */
					q->next = NULL;
					enemy_end = q;
					p->next = enemy_null_top;
					enemy_null_top = p;
					p = q->next;
				} else {
					q->next = p->next;
					p->next = enemy_null_top;
					enemy_null_top = p;
					p = q->next;
				}
			}
		} else {
			q = p;
			p = p->next;
		}
	}
}


void EnemyTini (void)
{
	int i;

    /* XgȂ */
	enemy_top = NULL;
	enemy_null_top = enemy;
	for (i = 0; i < ENEMY_MAX; i++)
		enemy[i].next = &enemy[i + 1];

	enemy[ENEMY_MAX - 1].next = NULL;
}
